﻿/*
 * SDK Pullenti Unitext, version 4.22, february 2024. Copyright (c) 2013, Pullenti. All rights reserved. 
 * Non-Commercial Freeware and Commercial Software. 
 * This class is generated using the converter UniSharping (www.unisharping.ru) from Pullenti C# project. 
 * The latest version of the code is available on the site www.pullenti.ru
 */

using System;

namespace Pullenti.Unitext
{
    /// <summary>
    /// Формат файла
    /// </summary>
    public enum FileFormat : int
    {
        /// <summary>
        /// Неизвестный формат
        /// </summary>
        Unknown = 0,
        /// <summary>
        /// Двоичный формат документа MsWord
        /// </summary>
        Doc,
        /// <summary>
        /// Открытый формат документа MsWord
        /// </summary>
        Docx,
        /// <summary>
        /// Специфический формат документа MsWord в Xml
        /// </summary>
        Docxml,
        /// <summary>
        /// Открытый формат MsPowerPoint
        /// </summary>
        Pptx,
        /// <summary>
        /// Portable Document Format (Adobe)
        /// </summary>
        Pdf,
        /// <summary>
        /// Текстовой файл в разных кодировках
        /// </summary>
        Txt,
        /// <summary>
        /// Hypertext Markup Language
        /// </summary>
        Html,
        /// <summary>
        /// Mime HtmFile
        /// </summary>
        Mht,
        /// <summary>
        /// Rich Text Format
        /// </summary>
        Rtf,
        /// <summary>
        /// Двоичный формат таблицы MsExcel
        /// </summary>
        Xls,
        /// <summary>
        /// Открытый формат таблицы MsExcel
        /// </summary>
        Xlsx,
        /// <summary>
        /// Специфический формат таблицы MsExcel в Xml
        /// </summary>
        Xlsxml,
        /// <summary>
        /// Comma-Separated Values, текстовое представление таблицы
        /// </summary>
        Csv,
        /// <summary>
        /// OpenOffice Document
        /// </summary>
        Odt,
        /// <summary>
        /// OpenOffice Spreadsheet
        /// </summary>
        Ods,
        /// <summary>
        /// Дежавю-формат
        /// </summary>
        DjVu,
        /// <summary>
        /// FictionBook (FeedBook) версии 2
        /// </summary>
        Fb2,
        /// <summary>
        /// FictionBook (FeedBook) версии 3
        /// </summary>
        Fb3,
        /// <summary>
        /// Electronic Publication
        /// </summary>
        Epub,
        /// <summary>
        /// Письмо формата MsOutlook
        /// </summary>
        Msg,
        /// <summary>
        /// Почтовый формат
        /// </summary>
        Eml,
        /// <summary>
        /// Zip-архив
        /// </summary>
        Zip,
        /// <summary>
        /// Rar-архив
        /// </summary>
        Rar,
        /// <summary>
        /// Tar-архив
        /// </summary>
        Tar,
        /// <summary>
        /// Gzip-архив
        /// </summary>
        Gzip,
        /// <summary>
        /// Zip7-архив
        /// </summary>
        Zip7,
        /// <summary>
        /// Картинка Bmp
        /// </summary>
        Bmp,
        /// <summary>
        /// Картинка Jpeg
        /// </summary>
        Jpg,
        /// <summary>
        /// Картинка Jpeg2000
        /// </summary>
        Jpg2000,
        /// <summary>
        /// Картинка Tiff
        /// </summary>
        Tif,
        /// <summary>
        /// Картинка Pgn
        /// </summary>
        Png,
        /// <summary>
        /// Картинка Gif
        /// </summary>
        Gif,
        /// <summary>
        /// Картинка Enhanced Windows Metafile
        /// </summary>
        Emf,
        /// <summary>
        /// Xml-формат
        /// </summary>
        Xml,
        /// <summary>
        /// XML Paper Specification File
        /// </summary>
        Xps,
    }
}